
// rsvna_assigning_channels_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsvna_assigning_channels_example.h"
#include "rsvna_assigning_channels_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ARRAY_SIZE    5000
#define STRING_LENGTH 512

#define CHECKERR(fcal) if ((rsvna_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsvna_assigning_channels_exampleDlg dialog




Crsvna_assigning_channels_exampleDlg::Crsvna_assigning_channels_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsvna_assigning_channels_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(TRUE)
	, m_Channel(1)
	, m_TraceName(_T("TrcDisp"))
	, m_SOutPort(1)
	, m_SInPort(1)
	, m_TraceFormat(2)
	, m_TraceCatalog(_T(""))
	, m_Window(1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsvna_assigning_channels_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CHANNEL, m_Channel);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_TRACE_NAME, m_TraceName);
	DDX_Text(pDX, IDC_S_OUT_PORT, m_SOutPort);
	DDX_Text(pDX, IDC_S_IN_PORT, m_SInPort);
	DDX_CBIndex(pDX, IDC_TRACE_FORMAT, m_TraceFormat);
	DDX_Text(pDX, IDC_TRACE_CATALOG, m_TraceCatalog);
	DDX_Text(pDX, IDC_WINDOW, m_Window);
}

BEGIN_MESSAGE_MAP(Crsvna_assigning_channels_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsvna_assigning_channels_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsvna_assigning_channels_exampleDlg message handlers

BOOL Crsvna_assigning_channels_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsvna_assigning_channels_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsvna_assigning_channels_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsvna_assigning_channels_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	ViInt32 trace = 0;
	ViInt32 buffer_size = STRING_LENGTH;
	ViChar  catalog[STRING_LENGTH] = "";

	/* initialize driver */
    CHECKERR (rsvna_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
    
    m_TraceCatalog = "";

	UpdateData(false);

	/* switch device display on/off */
    CHECKERR( rsvna_SetAttributeViInt32 (m_InstrSession, "", RSVNA_ATTR_DISPLAY_UPDATE, m_Display));
    
    /* Add a new channel if it doesn't exist */
    CHECKERR (rsvna_ChannelAdd (m_InstrSession, m_Channel, ""));
    
    /* Create a new trace */
    CHECKERR (rsvna_SelectSParameters (m_InstrSession, m_Channel, (char *) ((LPCTSTR) W2A(m_TraceName.LockBuffer())), m_SOutPort, m_SInPort));
    
    /* Select active trace */
    CHECKERR (rsvna_TraceSelect (m_InstrSession, m_Channel, ((char *) ((LPCTSTR) W2A(m_TraceName.LockBuffer())))));
    
    /* Change the format for trace */
    CHECKERR (rsvna_ConfigureTraceFormat (m_InstrSession, m_Channel, m_TraceFormat, 10));
    
    /* Display the trace in the display area */
    CHECKERR (rsvna_TraceAssignDiagramArea (m_InstrSession, m_Window, ((char *) ((LPCTSTR) W2A(m_TraceName.LockBuffer())))));

    /* List the traces, assigned to a certain Channel */
    CHECKERR (rsvna_TraceList (m_InstrSession, m_Channel, catalog, buffer_size));

	m_TraceCatalog = CString (catalog);

	AfxMessageBox ( _T( "You should be able to see the added trace on the instrument now. Press OK to continue."));
    
    /* Find the number for the trace */
    CHECKERR (rsvna_QueryTraceNumber (m_InstrSession, ((char *) ((LPCTSTR) W2A(m_TraceName.LockBuffer()))), &trace));
    
    /* Remove the trace from the diagram area */
    CHECKERR (rsvna_TraceUnassignDiagramArea (m_InstrSession, m_Window, trace));

    /* Delete a trace with a specified trace name and channel. */
    CHECKERR (rsvna_TraceDelete (m_InstrSession, m_Channel, ((char *) ((LPCTSTR) W2A(m_TraceName.LockBuffer())))));

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	CHECKERR (rsvna_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsvna_assigning_channels_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsvna_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsvna_error_message(m_InstrSession, rsvna_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsvna_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsvna_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsvna_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}