
// rsvna_marker_search_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsvna_marker_search_example.h"
#include "rsvna_marker_search_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define STRING_LENGTH 512  

#define CHECKERR(fcal) if ((rsvna_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsvna_marker_search_exampleDlg dialog




Crsvna_marker_search_exampleDlg::Crsvna_marker_search_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsvna_marker_search_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(true)
	, m_Reset(true)
	, m_Display(true)
	, m_Marker(1)
	, m_PeakType(0)
	, m_Position(0.0)
	, m_Amplitude_X(0.0)
	, m_Amplitude_Y(0.0)
{
	m_InstrSession = NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsvna_marker_search_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_MARKER, m_Marker);
	DDX_CBIndex(pDX, IDC_PEAKTYPE, m_PeakType);
	DDX_Text(pDX, IDC_POSITION, m_Position);
	DDX_Text(pDX, IDC_AMPLITUDE_X, m_Amplitude_X);
	DDX_Text(pDX, IDC_AMPLITUDE_Y, m_Amplitude_Y);
	DDX_Control(pDX, IDC_SEARCH, m_SearchControl);
}

BEGIN_MESSAGE_MAP(Crsvna_marker_search_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SEARCH, &Crsvna_marker_search_exampleDlg::OnBnClickedSearch)
	ON_BN_CLICKED(IDC_START, &Crsvna_marker_search_exampleDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &Crsvna_marker_search_exampleDlg::OnBnClickedStop)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// Crsvna_marker_search_exampleDlg message handlers

BOOL Crsvna_marker_search_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsvna_marker_search_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsvna_marker_search_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


// Sets peak excursion value, reads position of selected marker and writes marker 
//  position to panel
void Crsvna_marker_search_exampleDlg::OnBnClickedSearch()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	ViReal64    horizontalPos    = 0.0;
    ViReal64    amplitude[2];
    ViChar      rep_cap [STRING_LENGTH] = "";

	sprintf_s (rep_cap, "Channel1,Mk%ld", m_Marker);
    
    /* Enable marker. */
    CHECKERR (rsvna_SetAttributeViBoolean (m_InstrSession, rep_cap, RSVNA_ATTR_MARKER_STATE, VI_TRUE));
    
    /* specifies the type of marker search and performs the search */
    CHECKERR (rsvna_MarkerSearch (m_InstrSession, 1, m_Marker, m_PeakType));

    /* returns the position of the selected marker */
    CHECKERR (rsvna_GetAttributeViReal64 (m_InstrSession, rep_cap, RSVNA_ATTR_MARKER_STIMULUS, &horizontalPos));
    CHECKERR (rsvna_QueryMarkerResponse (m_InstrSession, 1, m_Marker, amplitude));

	m_Position = horizontalPos;
	m_Amplitude_X = amplitude[0];
	m_Amplitude_Y = amplitude[1];

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
}

// Configures the instrument and initiates the measurement
void Crsvna_marker_search_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	ViReal64    horizontalPos    = 0.0;
    ViReal64    amplitude[2];
    ViChar      rep_cap [STRING_LENGTH] = "";

	/* initialize driver */
    CHECKERR (rsvna_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
    
    /* switch device display on/off */
    CHECKERR( rsvna_SetAttributeViInt32 (m_InstrSession, "", RSVNA_ATTR_DISPLAY_UPDATE, m_Display));
    
	/* Set instrument to single sweep mode - continous mode is done
     * programmatically because this is the only way how to
     * synchronize measurement using *OPC
     */
    CHECKERR (rsvna_ConfigureAcquisition (m_InstrSession, 1, RSVNA_VAL_SWEEP_SINGLE_CHAN, VI_FALSE, 10, RSVNA_VAL_SWEEP_ALL_CHAN));
    
    sprintf_s (rep_cap, "Channel1,Mk%ld", m_Marker);
    
    /* Enable marker. */
    CHECKERR (rsvna_SetAttributeViBoolean (m_InstrSession, rep_cap, RSVNA_ATTR_MARKER_STATE, VI_TRUE));
    
    /* Perform Sweep */
    CHECKERR (rsvna_RestartSweep (m_InstrSession, 1, RSVNA_VAL_SWEEP_ALL_CHAN));

    /* specifies the type of marker search and performs the search */
    CHECKERR (rsvna_MarkerSearch (m_InstrSession, 1, m_Marker, m_PeakType));

    /* returns the position of the selected marker */
    CHECKERR (rsvna_GetAttributeViReal64 (m_InstrSession, rep_cap, RSVNA_ATTR_MARKER_STIMULUS, &horizontalPos));
    CHECKERR (rsvna_QueryMarkerResponse (m_InstrSession, 1, m_Marker, amplitude));

	m_Position = horizontalPos;
	m_Amplitude_X = amplitude[0];
	m_Amplitude_Y = amplitude[1];

	GetDlgItem(IDC_SEARCH)->EnableWindow(TRUE);

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
}

void Crsvna_marker_search_exampleDlg::OnBnClickedStop()
{
	cleanup (VI_FALSE);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsvna_marker_search_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsvna_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsvna_error_message(m_InstrSession, rsvna_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsvna_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsvna_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	if (m_InstrSession != NULL)
		rsvna_close (m_InstrSession);

	GetDlgItem(IDC_SEARCH)->EnableWindow(FALSE);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}

void Crsvna_marker_search_exampleDlg::OnClose()
{
	cleanup (VI_FALSE);

	CDialog::OnClose();
}
