
// rsvna_saving_and_recalling_error_terms_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsvna_saving_and_recalling_error_terms_example.h"
#include "rsvna_saving_and_recalling_error_terms_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ARRAY_SIZE    5000
#define STRING_LENGTH 512
#define WINDOW        1

ViReal64            amplitude [10][ARRAY_SIZE];
ViInt32             values_returned[10];

#define CHECKERR(fcal) if ((rsvna_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }
// Crsvna_saving_and_recalling_error_terms_exampleDlg dialog




Crsvna_saving_and_recalling_error_terms_exampleDlg::Crsvna_saving_and_recalling_error_terms_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsvna_saving_and_recalling_error_terms_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(TRUE)
	, m_StartFrequency(1000000000)
	, m_StopFrequency(4000000000)
	, m_SweepPoints(201)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsvna_saving_and_recalling_error_terms_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_START_FREQUENCY, m_StartFrequency);
	DDX_Text(pDX, IDC_STOP_FREQUENCY, m_StopFrequency);
	DDX_Text(pDX, IDC_SWEEP_POINTS, m_SweepPoints);
}

BEGIN_MESSAGE_MAP(Crsvna_saving_and_recalling_error_terms_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_SAVE_ERROR_TERMS, &Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedSaveErrorTerms)
	ON_BN_CLICKED(IDC_RECALL_ERROR_TERMS, &Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedRecallErrorTerms)
END_MESSAGE_MAP()


// Crsvna_saving_and_recalling_error_terms_exampleDlg message handlers

BOOL Crsvna_saving_and_recalling_error_terms_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsvna_saving_and_recalling_error_terms_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsvna_saving_and_recalling_error_terms_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsvna_saving_and_recalling_error_terms_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsvna_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsvna_error_message(m_InstrSession, rsvna_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsvna_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsvna_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	if (m_InstrSession != NULL)
		rsvna_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}

void Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	/* initialize driver */
    CHECKERR (rsvna_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
    
    /* switch device display on/off */
    CHECKERR( rsvna_SetAttributeViInt32 (m_InstrSession, "", RSVNA_ATTR_DISPLAY_UPDATE, m_Display));
    
	/* Set frequency range */
    CHECKERR (rsvna_ConfigureFrequencyStartStop (m_InstrSession, 1, m_StartFrequency, m_StopFrequency));
    
    /* Set number of sweep points */
    CHECKERR (rsvna_ConfigureSweepNumberOfPoints (m_InstrSession, 1, m_SweepPoints));

    /*  */
    CHECKERR (rsvna_SelectCalibrationType (m_InstrSession, 1, "Test SFK TOSM 12", RSVNA_VAL_CALTYPE_TOSM, 1, 2, 0, 0));
        
    /* Measure Standards */
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for THROUGH calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_THR, 1, 2));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for OPEN port 1 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_OPEN, 1, 0));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for SHORT port 1 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_SHORT, 1, 0));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for MATCH port 1 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_MATCH, 1, 0));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for OPEN port 2 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_OPEN, 2, 0));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for SHORT port 2 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_SHORT, 2, 0));
    AfxMessageBox ( _T( "Connect/disconnect calibration unit for MATCH port 2 calibration step."));
    CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_MATCH, 2, 0));

    
    /* Apply calibration */
    CHECKERR (rsvna_SaveCalibrationData (m_InstrSession, 1)); 
    
    /* Save error terms */
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 1, ARRAY_SIZE, &values_returned[0], amplitude[0]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 2, ARRAY_SIZE, &values_returned[1], amplitude[1]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 3, ARRAY_SIZE, &values_returned[2], amplitude[2]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 5, ARRAY_SIZE, &values_returned[3], amplitude[3]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 6, ARRAY_SIZE, &values_returned[4], amplitude[4]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 7, ARRAY_SIZE, &values_returned[5], amplitude[5]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 8, ARRAY_SIZE, &values_returned[6], amplitude[6]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 9, ARRAY_SIZE, &values_returned[7], amplitude[7]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 11, ARRAY_SIZE, &values_returned[8], amplitude[8]));
    CHECKERR (rsvna_TraceResponseDataError (m_InstrSession, 1, 12, ARRAY_SIZE, &values_returned[9], amplitude[9]));

	GetDlgItem (IDC_SAVE_ERROR_TERMS)->EnableWindow(TRUE);
	GetDlgItem (IDC_RECALL_ERROR_TERMS)->EnableWindow(TRUE);

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
}

void Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedSaveErrorTerms()
{
	ViChar buffer[500*STRING_LENGTH];
    ViChar temp[STRING_LENGTH];
    ViInt32  i                      = 0,
             x                      = 0;
    FILE   *targetFile              = NULL;
    ViChar file_name[STRING_LENGTH] = "";
	ViUInt32 bytesReadInstr         = 0,
             bytesWrittenFile       = 0;
    CString dlg_file;
	
	CFileDialog file_dlg (FALSE, NULL, NULL, NULL, NULL, NULL);
	
	if (file_dlg.DoModal() == IDOK)
	{
		// change cursor to glasshours
		HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
		SetCursor ( cur );

		dlg_file = file_dlg.GetPathName();
		CT2CA file_name(dlg_file);
		targetFile = fopen (file_name, "w");         
		
		for (x = 0; x < 10; x++)
        {
            for (i = 0; i < values_returned[x]; i++)
            {
                sprintf_s (temp, "%lf,", amplitude[x][i]);
                strcat_s (buffer, temp);
            }
            strcat_s (buffer, "\n");
        }

		bytesWrittenFile = (ViUInt32) fwrite (buffer, sizeof (ViByte), (size_t)strlen (buffer), targetFile);
            
        (void) fclose (targetFile);

		cur = LoadCursor (NULL, IDC_ARROW);
		SetCursor (cur);
	}
}

void Crsvna_saving_and_recalling_error_terms_exampleDlg::OnBnClickedRecallErrorTerms()
{
	ViChar file_name[STRING_LENGTH] = "";
	FILE   *sourceFile              = NULL;
	ViChar buffer[500*STRING_LENGTH];
	ViChar *temp;
	ViUInt32 bytesRead              = 0,
			 bytesWrittenFile       = 0;
	ViInt32  i                      = 0,
			 x                      = 0;
	ViChar *p2buf;
	CString dlg_file;
	long  fileLen;

	CFileDialog file_dlg (TRUE, NULL, NULL, NULL, NULL, NULL);
	
	if (file_dlg.DoModal() == IDOK)
	{
		// change cursor to glasshours
		HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
		SetCursor ( cur );

		dlg_file = file_dlg.GetPathName();
		CT2CA file_name(dlg_file);
		
		sourceFile = fopen (file_name, "r");
	            
		fseek(sourceFile, 0L, SEEK_END);  /* Position to end of file */
        fileLen = ftell(sourceFile);     /* Get file length */
        rewind(sourceFile);               /* Back to start of file */
        
        temp = (ViChar*) calloc(fileLen + 1, sizeof(ViChar));
        
        fread(temp, fileLen, 1, sourceFile);
        
        (void) fclose (sourceFile);
        
        strcpy (buffer, temp);
        
        p2buf = strtok (buffer, ",");
	    
		while (p2buf != NULL && i < 10)
		{
			amplitude[i][x++] = atof (p2buf);
			p2buf = strtok (NULL, ",");
			if (strstr (p2buf, "\n"))
			{
				values_returned[i] = x;
                i++;
				x = 0;
			}
		}
	    
		/* Generate a set of default correction data, switch on user calibration */
		CHECKERR (rsvna_GenerateDefaultCalibrationData (m_InstrSession, 1));
	    
		CHECKERR (rsvna_ConfigureSystemErrorCorrectionState (m_InstrSession, 1, VI_TRUE));
	    
		/* !!! Important !!! Stop sweep when loading error terms */
		CHECKERR (rsvna_ConfigureAcquisition (m_InstrSession, 1, RSVNA_VAL_SWEEP_ALL_CHAN, VI_FALSE, 10, RSVNA_VAL_SWEEP_ALL_CHAN));
	    
		/* Recall error terms */
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 0, 1, 0, amplitude[0]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 1, 1, 0, amplitude[1]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 2, 1, 0, amplitude[2]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 3, 1, 2, amplitude[3]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 4, 1, 2, amplitude[4]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 0, 2, 0, amplitude[5]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 1, 2, 0, amplitude[6]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 2, 2, 0, amplitude[7]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 3, 2, 1, amplitude[8]));
		CHECKERR (rsvna_WriteCalibrationData (m_InstrSession, 1, 4, 2, 1, amplitude[9]));
		
		cur = LoadCursor (NULL, IDC_ARROW);
		SetCursor (cur);
	}
}
