
// rsvna_single_sweep_mode_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsvna_single_sweep_mode_example.h"
#include "rsvna_single_sweep_mode_exampleDlg.h"
#include <fstream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ARRAY_SIZE    5000

ViReal64 data[999][5000];
ViInt32 values[999];

#define CHECKERR(fcal) if ((rsvna_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsvna_single_sweep_mode_exampleDlg dialog




Crsvna_single_sweep_mode_exampleDlg::Crsvna_single_sweep_mode_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsvna_single_sweep_mode_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(TRUE)
	, m_SweepTime(1)
	, m_SweepCount(1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsvna_single_sweep_mode_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_SWEEP_TIME, m_SweepTime);
	DDX_Text(pDX, IDC_SWEEP_COUNT, m_SweepCount);
}

BEGIN_MESSAGE_MAP(Crsvna_single_sweep_mode_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsvna_single_sweep_mode_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsvna_single_sweep_mode_exampleDlg message handlers

BOOL Crsvna_single_sweep_mode_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsvna_single_sweep_mode_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsvna_single_sweep_mode_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsvna_single_sweep_mode_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsvna_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsvna_error_message(m_InstrSession, rsvna_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsvna_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsvna_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	if (m_InstrSession != NULL)
		rsvna_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}

void Crsvna_single_sweep_mode_exampleDlg::OnBnClickedStart()
{
	ViInt32 channel = 1;
	ViInt32 sweep = 1;
	ViInt32 buffer_size = 5000;
	ViStatus temp_status  = VI_SUCCESS;
    ofstream	out_file;

	CFileDialog file_dlg (FALSE, NULL, NULL, NULL, NULL, NULL);
	
	if (file_dlg.DoModal() == IDOK)
	{
		USES_CONVERSION;
		UpdateData ();
		HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
		SetCursor ( cur );
		
		/* initialize driver */
		CHECKERR (rsvna_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	    
		/* switch device display on/off */
		CHECKERR( rsvna_SetAttributeViInt32 (m_InstrSession, "", RSVNA_ATTR_DISPLAY_UPDATE, m_Display));
	    
		/* Configure Sweep Time */
		CHECKERR (rsvna_ConfigureSweepTime (m_InstrSession, channel, VI_FALSE, m_SweepTime));
	    
		/* Set instrument to single sweep mode - continous mode is done
		 * programmatically because this is the only way how to
		 * synchronize measurement using *OPC
		 */
		CHECKERR (rsvna_ConfigureAcquisition (m_InstrSession, channel, RSVNA_VAL_SWEEP_ALL_CHAN, VI_FALSE, m_SweepCount, RSVNA_VAL_SWEEP_ALL_CHAN));
	    
		/* Perform Sweep */
		CHECKERR (rsvna_RestartSweep (m_InstrSession, channel, RSVNA_VAL_SWEEP_ALL_CHAN));

		for (sweep = 1; sweep <= m_SweepCount; sweep++)
		{
			/* Reads the response values of a trace acquired in single sweep mode. */
			temp_status = rsvna_TraceResponseSingleSweepData (m_InstrSession, channel, sweep, ARRAY_SIZE, &values[sweep - 1], data[sweep - 1]);
	            
			if( temp_status != VI_SUCCESS )
			{
				/* check error (specan driver) and prompt it */
				cleanup(VI_FALSE);
				return;
			}
		}

		out_file.open(file_dlg.GetPathName());
		
		for (sweep = 1; sweep <= m_SweepCount; sweep++)
		{
			out_file << "Sweep data " << sweep << " (real, imaginary): ";
			
			for (int i = 0 ; i < values[sweep - 1]; i++)
			{
				out_file << data[sweep - 1][i] << "; ";
			}
			out_file << "\n\n";
		}
		out_file.close();

		UpdateData(false);

		cur = LoadCursor (NULL, IDC_ARROW);
		SetCursor (cur);
	}
}
